export declare const ox: () => void;
export declare const falsePromise: Promise<unknown>;
export declare const isNumber: (n: any) => boolean;
export declare const timeout: (ms: number) => Promise<unknown>;
export declare const sleep: (ms: number) => Promise<unknown>;
export declare function err(msg: string): void;
export declare function getRandomInt(min?: number, max?: number): number;
declare type Fn = (...args: any[]) => any;
export declare function debounce<T extends Fn>(fn: T, ms?: number): (...p: Parameters<T>) => void;
interface IDebouncer<T extends Fn> {
    debounce: (...p: Parameters<T>) => void;
    exec: () => void;
    setAwaitTime: (x: number) => void;
}
export declare function Debouncer<T extends Fn>(fn: T, ms?: number): IDebouncer<T>;
export declare const wait: <T extends Fn>(fn: T) => (...p: Parameters<T>) => Promise<void>;
export declare const throttle: <T extends Fn>(fn: T, ms: number) => (...p: Parameters<T>) => Promise<void>;
export declare const shield: <T extends Fn>(fn: T, ms: number) => (...p: Parameters<T>) => void;
declare type Key = string | number | symbol;
export declare function factory<T extends (arg: Key) => any>(setterFunction: T, o?: Record<Key, ReturnType<T>>): Record<Key, ReturnType<T>>;
export declare function mapFactory<T extends Fn>(setterFunction: T, m?: Map<any, any>): {
    (prop: Parameters<T>[0]): ReturnType<T>;
    __map: Map<any, any>;
};
export declare function cacher<T extends Fn>(f: T, m?: Map<any, any>): {
    (...params: Parameters<T>): ReturnType<T>;
    _map: Map<any, any>;
};
declare type RemoveLast<T extends any[]> = T extends [...infer ts, infer t] ? [...ts] : [];
export declare const cell: <T extends Fn>(f: T, m: ReturnType<T>) => (...args: RemoveLast<Parameters<T>>) => any;
export {};
